QGIS Application - Bug report #4227

Vector layer query fails if SQL text contains not ascii characters (but works in advanced search in
the table of attributes)

2011-08-26 05:38 AM - marisn -

Status: Closed

Priority: High

Assignee:

Category: Vectors

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 14184
Description

Steps to reproduce:

1) Add a vector layer with attribute data in different encoding;

2) Open layer definition query dialog;

3) Enter any clause that contains non-latin letter (i.e. FOO like '%€%").

Result - it reports 0 rows matching.
Same clause within attribute table "advanced query dialog" results in numerous results.

If dataset encoding matches current system encoding, SQL part runs fine and bug is not present.

Tested with 1.7.0 and current git.

Associated revisions

Revision cfcfa080 - 2012-01-26 09:24 PM - Jiirgen Fischer

fix #4227

History

#1 - 2011-08-29 10:33 PM - Paolo Cavallini

- Category set to Vectors

#2 - 2011-10-30 11:46 PM - peppo -

| encountered a quite similar issue. When the query on a shape layer (on windows with system encoding) contains special characters like U the
coresponding feature is not selected. When | take the the same shape file and use the "save as ..." with utf-8, the query works fine on the new layer.

| think this behaviour is problematic, because one might not notice a single feature missing and it changes the result of a query.

If anybody needs example files, | would be happy to provide them.

#3 - 2011-11-12 05:51 AM - Tim Sutton

- Target version changed from Version 1.7.1 to Version 1.7.2

#4 - 2011-11-30 12:40 PM - Giovanni Manghi

- Target version changed from Version 1.7.2 to Version 1.7.3
#5 - 2011-12-16 10:54 AM - Giovanni Manghi

- Target version changed from Version 1.7.3 to Version 1.7.4
#6 - 2012-01-26 04:33 AM - Giovanni Manghi

- Affected QGIS version set to master
- Crashes QGIS or corrupts data set to No

This is still confirmed on master. You can use the vector attached to #4433 to test it.

#7 - 2012-01-26 11:55 AM - Giovanni Manghi

The problem is worst as the same issue is there even if the layer is opened with the correct encoding and the query contains non-ascii chars

example:

download this

http://www.igeo.pt/produtos/cadastro/caop/download/CAOP2011_Shapes/Cont_ AAd_CAOP2011.zip

which is in is0-8859-1

then query

"Freguesia" = 'PECHAQ'

it will return 0 results

but the same query will work from the advances search in the attribute table

#8 - 2012-01-26 11:56 AM - Giovanni Manghi

- Subject changed from Vector layer data query fails to select objects if SQL text contains not default encoding characters to Vector layer query fails if

SQL text contains not ascii characters (but works in advanced search in the table of attributes)

- Priority changed from Normal to High

tested on master

#9 - 2012-01-26 12:24 PM - Jiirgen Fischer
- % Done changed from 0 to 100
- Status changed from Open to Closed

Fixed in changeset commit:"cfcfa0802fabbd42810c6139¢c00f2dc08f454c18".
